% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $
%
function f=mtimes(plan,fhat)


M2=size(fhat,1);

if (M2~=size(plan.MOmega,1))
    error('fhat and MOmega must have the same length');
end

    switch plan.Ftype
        case 'LT'
            
            if (~isempty(plan.blocksize))
                f=mtimes_LT_smallblocks(plan,fhat);
            else
                f=mtimes_LT(plan,fhat);
            end
            
        case {'FFLT','NFFLT','NNFFLT','BSFFLT'}
            if (~isempty(plan.blocksize))
                f=mtimes_XFFLT_smallblocks(plan,fhat);
            else
                f=mtimes_XFFLT(plan,fhat);
            end
            
        
        otherwise
            error('Not enough input parameters, MOmega is missing')
    end

end