% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $
%
function [Omega]=Geom(MOmega,M)
%INPUT
%   - MOmega: row vector of nodes, nodes are monotonically increasing
%   - M: number of Boxes
%OUTPUT
%   - Omega: Matrix of size Kx3, where K is the number of nonempty boxes
%            Omega=[K,idx1,idx2], where MOmega(idx1:idx2) \in Omega_K
        
        
        M2=length(MOmega);
        maxxi=max(MOmega);
        Omega=[]; %Computes the Boxes Omega_K =[K,idx1,idx2] the nodes Omega(idx1)-Omega(idx2) are in the box
              
        start_idx=M2;
        K=1;
        while( (K<=M-1) && (start_idx>=1) )
            %K
            [index]=GetIndex(MOmega,start_idx,maxxi,K);

            %display('**********************************************************')
            %index
            if(~isempty(index))
                %display('Index ist nicht leer')
                Omega=[Omega;K,index,start_idx];
                %Omega
                start_idx=index-1;
            %else
                %display('Index ist leer')
                
            end
            
            K=K+1;
            %pause

        
        end%while
        
        %start_idx
        %Computation of Box M
        if(start_idx>=1)
             Omega=[Omega;M,1,start_idx];
        end
        

        
end%function
        
 


