% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $
%
function u=exact_eval(MY,MX,MOmega,N,fhat)

%
% u=u_exactall(MX,MOmega,f,N)
%
% INPUT
%    MX      - sampling nodes in X=[0,N] as row vector
%    MY      - sampling nodes in Y in R_+ as row vector
%    MOmega  - sampling nodes in Omega=[0,N] as row vector
%
% OUTPUT
%   u  complex column vector of length size(MX,1)

M1=size(MY,1);
M2=size(MOmega,1);
n=size(fhat,2);
u=zeros(M1,n);


Z=MX./N+1i*MY./(2*pi);
for l=1:n
    for k=1:M2
			u(:,l)=u(:,l)+(exp(2*pi*1i*Z*MOmega(k))*fhat(k,l));
    end
    
end


end