% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $
%
function f=mtimes_LT(plan,fhat)

n=size(fhat,2);
M1=size(plan.MY,1);
f=zeros(M1,n);

%Approximation case Y_I=Y_M
    if(plan.Y(end,1)==plan.M)    
        %display('Approximation 1')
        f(plan.Y(end,2):plan.Y(end,3))=sum(fhat);     
    end    

    
    
    S=zeros(n,plan.Omega_num);%Computation of sums S_K
    if (plan.Omega(plan.Omega_num,1)==plan.M)
        S(:,end)=sum(fhat(plan.Omega(end,2):plan.Omega(end,3),:));
    end
    
    V=zeros(plan.q,n*(plan.Kend));%Computation of v^{Omega_K}
    for tmpK=1:plan.Kend        
        S(:,tmpK)=sum(fhat(plan.Omega(tmpK,2):plan.Omega(tmpK,3),:));
        %display('K=')    
        K=plan.Omega(tmpK,1);
            
        if(K==plan.M)
            display('FEHLER K !=M')
        end
        c=3*plan.maxxi/2^(K+1);
        w=plan.maxxi/2^K;
        %display('Mittelpunkt=')
        %c
        xi_cheb=c+1/2*w*plan.t;
        Omega_K=plan.MOmega(plan.Omega(tmpK,2):plan.Omega(tmpK,3)); %row vector of nodes in Omega_K
        vecf_K=fhat(plan.Omega(tmpK,2):plan.Omega(tmpK,3),:); %appropriate vector of Coefficients

        L=zeros(plan.q,size(Omega_K,1));
        for s=1:plan.q
            L(s,:)=LagPol(plan.q,Omega_K,xi_cheb,s); %L_s^{Omega_k}(xi_0^\Omega_K,...,xi_{q-1}^\Omega_K)
        end  
    
        
        %V(:,tmpK)=(L*vecf_K);            
        V(:,(tmpK-1)*n+1:tmpK*n)=L*vecf_K;
    end%for tmpK
    
    S=cumsum(fliplr(S));
    S=fliplr(S); 
    
    

    vec_K=plan.Omega(:,1);
	%H=zeros(plan.q,plan.Iend);
	for tmpI=1:plan.Iend
        I=plan.Y(tmpI,1);
        

        n1=size(plan.Y(tmpI,2):plan.Y(tmpI,3),2); %number of nodes in Y_I   
        
        
        idxK=find((vec_K>=plan.l(tmpI)+1) & (vec_K<=plan.m(tmpI)-1)); %indexnumber in Omega with the condition in find

        c=3*plan.maxy/2^(I+1);
        w=plan.maxy/2^I;
        y_cheb=c+1/2*w*plan.t;
        
        %Computation of h^{Y_I}  
        if(plan.m(tmpI) >1)
            
            Y_I=plan.MY(plan.Y(tmpI,2):plan.Y(tmpI,3)); %column vector of nodes in Y_I
                                                                    
            sumK=vec_K(idxK); %number K of non empty boxes K
                        
            h=zeros(plan.q,n);
                        
            for tmp=1:length(sumK)
                              
              
                     K=sumK(tmp);                                              
                     c_Omega_K=3*plan.maxxi/2^(K+1);
                     w_Omega_K=plan.maxxi/2^K;
                     xi_cheb=c_Omega_K+1/2*w_Omega_K*plan.t;
                     E=exp(-y_cheb.'*xi_cheb); 
 
                     idx=idxK(tmp);
                     %v_K=V(:,idxK(tmp));
                     v_K=V(:,(idx-1)*n+1:idx*n);
                     h=h+E*v_K;
            end%for tmp     
        end%if 
        
        
        
        %Computation of the approximation     
        LYI=zeros(size(Y_I,1),plan.q);
        for r=1:plan.q
            LYI(:,r)=LagPol(plan.q,Y_I,y_cheb,r); %L_s^{Y_I}(y_0^Y_I,...,y_{q-1}^Y_I)
        end%for r, LYI

        f(plan.Y(tmpI,2):plan.Y(tmpI,3),:)=f(plan.Y(tmpI,2):plan.Y(tmpI,3),:)+LYI*h;
        
        
        %Summing up approximation case (ii) and (iii)
        if(plan.m(tmpI)>=1)
            idxK=find(vec_K>=plan.m(tmpI));
            if(~isempty(idxK))
                %S(:,idxK(1))
               f(plan.Y(tmpI,2):plan.Y(tmpI,3),:)=f(plan.Y(tmpI,2):plan.Y(tmpI,3),: )+S(:,idxK(1));
            end
        end%if         
        
	end%for tmpI
      
    
	
  
    
end%mtimes