% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $
%
function f=mtimes_XFFLT(plan,fhat)

f=zeros(size(plan.MY));
M2=length(fhat);

%Approximation case Y_I=Y_M
    if(plan.Y(end,1)==plan.M) 

        tmp=plan.fhandle(plan,fhat); %XFFT

        f(plan.Y(end,2):plan.Y(end,3))=tmp(plan.Y(end,2):plan.Y(end,3));     
    end    
      
    vec_K=plan.Omega(:,1); %vector of indices of nonempty boxes Omega_K

	for tmpI=1:plan.Iend
        
        I=plan.Y(tmpI,1);
        idxK=find((vec_K>=plan.l(tmpI)+1) & (vec_K<=plan.m(tmpI)-1)); %indexnumber in Omega with the condition in find
        h=zeros(M2,1);  
        idxKgm=find(vec_K>=plan.m(tmpI));

        if(~isempty(idxKgm))
            h(1:(plan.Omega(idxKgm(1),3))) = fhat(1:plan.Omega(idxKgm(1),3));      
        end
        
        fhat_CupOmega=zeros(M2,1);
        if ( ~isempty(idxK) )

            fhat_CupOmega(plan.Omega(idxK(end),2) : plan.Omega(idxK(1),3))=fhat(plan.Omega(idxK(end),2) : plan.Omega(idxK(1),3)); %fhat_k : k\in Omega_K l_I+1<=K<=m_I-1
        end
        
        S=plan.fhandle(plan,h); %XFFT
        
        c=3*plan.maxy/2^(I+1);
        w=plan.maxy/2^I;
        y_cheb=c+1/2*w*plan.t;
        
        %Computation of h^{Y_I}  
        if(plan.m(tmpI) >1)
            
            %idxK=find((vec_K>=l(tmpI)+1) & (vec_K<=m(tmpI)-1)); %indexnumber in Omega with the condition in find
            %display('komplizierter Fall')
            
                                           
            sumK=vec_K(idxK); %number K of non empty boxes K
            %idxK
            %display('Indizes')
            %plan.Omega(idxK(1),2)
            %plan.Omega(idxK(end),2)
            
                        
            V=zeros(plan.q,length(plan.Y(tmpI,2):plan.Y(tmpI,3)));
            G=zeros(M2,plan.q);
            
                        
                
                for tmp=1:length(sumK)
                    K=sumK(tmp);
                    
                    c_Omega_K=3*plan.maxxi/2^(K+1);
                    w_Omega_K=plan.maxxi/2^K;
                    xi_cheb=c_Omega_K+1/2*w_Omega_K*plan.t;
                    E=exp(-y_cheb.'*xi_cheb); 

                    Omega_K=plan.MOmega(plan.Omega(idxK(tmp),2):plan.Omega(idxK(tmp),3)); %row vector of nodes in Omega_K
                    
                    L=zeros(size(Omega_K,1),plan.q);
                    
                    
                    for r=1:plan.q
                        L(:,r)=LagPol(plan.q,Omega_K,xi_cheb,r); %L_s^{Omega_k}(xi_0^\Omega_K,...,xi_{q-1}^\Omega_K)
                    end
                    %tmpg(plan.Omega(idxK(tmp),2):plan.Omega(idxK(tmp),3))=L*((E(s,:)).'); 
                    
                    G(plan.Omega(idxK(tmp),2):plan.Omega(idxK(tmp),3),:) = (L*(E.'));
                    
                end%for tmp    
                %size(tmpg)
                %size(fhat_CupOmega)
       
                for s=1:plan.q
                    g_s=fhat_CupOmega.*G(:,s);
                    tmpv=plan.fhandle(plan,g_s); %N*ifft(g_s);
                    V(s,:)=tmpv(plan.Y(tmpI,2):plan.Y(tmpI,3));
                end %for s
            
        end%if 
        
        
        
        %Computation of the approximation
        Y_I=plan.MY(plan.Y(tmpI,2):plan.Y(tmpI,3)); %row vector of nodes in Y_I
        
        
        LYI=zeros(size(Y_I,1),plan.q);
        for r=1:plan.q
            LYI(:,r)=LagPol(plan.q,Y_I,y_cheb,r); %L_s^{Y_I}(y_0^Y_I,...,y_{q-1}^Y_I)
        end
        %V
        %(sum(LYI.*V))   
        
        %pause
        f(plan.Y(tmpI,2):plan.Y(tmpI,3))=(sum(LYI.'.*V)).'+S(plan.Y(tmpI,2):plan.Y(tmpI,3)); 
        
        
        
	end%for tmpI
      
    
	
  
    
end%mtimes