% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $
%
function plan=precomputations(plan)        
       
        

        plan.Omega=Geom(plan.MOmega,plan.M);
        plan.Y=Geom(plan.MY,plan.M);
     
        plan.Omega_num=size(plan.Omega,1);  %number of Boxes Omega_K
        plan.Y_num=size(plan.Y,1);  %number of Boxes Y_I


        %set index maximal to M-1
        if plan.Omega(plan.Omega_num,1)==plan.M
            plan.Kend=plan.Omega_num-1;
        else plan.Kend=plan.Omega_num;
        end

        if plan.Y(plan.Y_num,1)==plan.M
            plan.Iend=plan.Y_num-1;   
        else plan.Iend=plan.Y_num;
        end

        plan.l=zeros(1,plan.Iend);
        plan.m=zeros(1,plan.Iend);
        for I=1:plan.Iend
            plan.l(I)=floor(log2(plan.maxy*plan.maxxi) - plan.Y(I,1) - log2(log(1/plan.epsilon))) ; %untere Schranke
            plan.m(I)=plan.M-plan.Y(I,1)+1; %ceil(log2(plan.maxy*plan.maxxi) - plan.Y(I,1) + log2(1/plan.epsilon) +2 ); %obere Schranke

        end
        %display('Indizes fuer unteren Summenindizes')
        plan.l(plan.l<=0)=0;
        
        %display('Indizes fuer obere Summenindizes')
        plan.m(plan.m>=plan.M)=plan.M;
        


        %Chebyshev-nodes in [-1,1]
        j=0:1:plan.q-1;
        plan.t=cos((2*j+1)/(2*plan.q)*pi);

        plan.lambda=(-1).^(j).*sin((2*j+1)/(2*plan.q)*pi);
        
        
        
%         %Matrix of combinations, which have to be evaluated exact
%         plan.MIK=zeros(plan.Iend,plan.Kend);
%         for tmpI=1:plan.Iend
%             %I=plan.Y(tmpI,1);
%             n1=size(plan.Y(tmpI,2):plan.Y(tmpI,3),2); %number of nodes in Y_I  
%             for tmpK=1:plan.Kend
%                % K=plan.Omega(tmpK,1);
%                 n2=size(plan.Omega(tmpK,2):plan.Omega(tmpK,3),2);
%                 
%                 if(n1*n2 <= plan.blocksize)
%                     plan.MIK(tmpI,tmpK)=1;
%                 end
%             
%                 
%             end
%         end
end