% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $

function u=comp_first_func_val3D(MOmega,p,N,xA1,xA2,xA3,B_index,f)

U=zeros(p,p,p);
for s1=1:p
    for s2=1:p
		for s3=1:p
			for j=1:length(B_index)
				xA=[xA1(s1),xA2(s2),xA3(s3)];
				xi_j=MOmega(B_index(j),:);
				U(s1,s2,s3)=U(s1,s2,s3)+exp(2*pi*1i*xA*(xi_j')/N)*f(B_index(j));
			end
		end
    end
end
u=U(:);
end%function