% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $

function tensor=nmode3D_coeff(F,U,p)
%Input: Tensor F \in \CC^{p x p xp}
%		Matrix U \in \CC^{p x p}
%tensor = F x_1 U x_2 U x_3 U


		tmpF=reshape(F,p,p^2);
		tmpF=U*tmpF;
		tensor=reshape(tmpF,p,p,p);
		
		tensor=permute(tensor,[2 1 3]);
		tmpF=reshape(tensor,p,p^2);
		tmpF=U*tmpF;
		tensor=reshape(tmpF,p,p,p);
		
		%tensor1=ipermute(tensor,[2 1 3]);
		%tensor2=shiftdim(tensor,2)

		%permute(tensor,[3 1 2])
		
		%tmpF=reshape(shiftdim(tensor,2),p,p^2);
		
		tensor=permute(tensor,[3 1 2]);
		tmpF=reshape(tensor,p,p^2);
		tmpF=U*tmpF;
		tensor=reshape(tmpF,p,p,p);
		%tensor2=shiftdim(tensor,2);
		tensor=permute(tensor,[3 2 1]);



		
end