% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $

function ls=lagpol_alpha(m,p,alpha,s)
%Input:	
	% m=0 for the left and m=1 for the right son
    % p, number of interpolation nodes
    % alpha Chebyshev grid in [-1/2,1/2]
    % parameter s for the s-th lagrange polynome
%Output: vector ls =[l_s(x_1),...,l_s(x_d)]
	ls=1;
	z=exp((-1)^(m)*pi*1i/(2*(p-1)))*exp(-pi*1i*alpha/(p-1));
    z_node=exp(-2*pi*1i*alpha/(p-1));

	z_s=z_node(s);
	
	for j=[1:s-1,s+1:p]
		z_j=z_node(j);
		ls=ls.*(z-z_j)/(z_s-z_j);
	end
end%function	