% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $

function Index=decompose_index3D(M, index_input, l_input, m1_input, m2_input, m3_input, N_input)
anzahl=length(index_input);

%indices of the 8 sons
index1=[];
index2=[];
index3=[];
index4=[];
index5=[];
index6=[];
index7=[];
index8=[];

for j=1:anzahl
	tmp=M(index_input(j),:); %select nodes of the matrix and check in which son the node lies
	
	test_var1=node_in_box(l_input+1,2*m1_input,N_input,tmp(1)); %check, if first node component lies in X_l+1,2m1 
	test_var2=node_in_box(l_input+1,2*m2_input,N_input,tmp(2)); %check, if second node component lies in X_l+1,2m2 
	test_var3=node_in_box(l_input+1,2*m3_input,N_input,tmp(3)); %check, if third node component lies in X_l+1,2m3 

		
	switch test_var1
		case 1 %in X_l+1,2m1			
			switch test_var2
				case 1 
					switch test_var3
						case 1
							index1=[index1 index_input(j)];
						case 0
							index2=[index2,index_input(j)];
					end%switch
				case 0
					switch test_var3
						case 1
							index3=[index3 index_input(j)];
						case 0
							index4=[index4,index_input(j)];
					end%switch

			end%switch
			
		case 0 %in X_l+1,2m1+1
				switch test_var2
				case 1 
					switch test_var3
						case 1
							index5=[index5 index_input(j)];
						case 0
							index6=[index6,index_input(j)];
					end%switch
				case 0
					switch test_var3
						case 1
							index7=[index7 index_input(j)];
						case 0
							index8=[index8,index_input(j)];
					end%switch
			end%switch
	end%switch var1
end		

%index sets of the 8 sons
Index={index1,index2,index3,index4,index5,index6,index7,index8};
end %function zerlegeIndex