% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%
%%
%add XFFT library
addpath('../..')

%add NFFT Library directories
%NFFTdir='/home/math/imelzer/software/nfft-3.3_optiplex/';
NFFTdir='/home/math/imelzer/software/nfft-3.3_Phi/'; 

%add utilities
addpath('../utilities');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N=2^10;
M2=N;
M1=N;
ximax=N-1;

MX=N*rand(M1,1);
fhat=complex(rand(M2,1)-1/2,rand(M2,1)-1/2);

qstart=1;
qmax=20;


vecq=qstart:1:qmax;
err=inf*ones(1,length(vecq));
err_theor=inf*ones(1,length(vecq)); %boundary for LT and FFLT
MOmega=(1:N).'; %equispaced Frequencies for all tests

savefile=sprintf('data/error1D_LT_Phi_N%d.mat',N);


for tmpq=1:length(vecq)
    q=vecq(tmpq);
    display(q)
    ymax=(2*q-1)*log(2);
    MY=ymax*sort(rand(M1,1));

    plan=XFLT('LT',MY,'rank',q,'MOmega',MOmega);
    u_ex=u_exactLT(MY,MOmega,fhat);
    
    f=mtimes(plan,fhat);
    
    [errmax,idx]=max(abs(u_ex-f));
    
    errmax
    
    err(tmpq)=norm(f-u_ex,Inf)/(norm(fhat,1));
    err_theor(tmpq)=2^(1-2*q);%1/4^(q)*(2+2/pi*log(q));
    
    save(savefile,'qstart','q','err','N','MX','MY','MOmega','fhat','err_theor')
end