% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%

%Vergleich auswertung trigonometrisches Polynom im Einheitskreis
N=2^(14);

%add XFFT library
addpath('../..')

%add NFFT Library directories
%NFFTdir='/home/math/imelzer/software/nfft-3.3_optiplex/';
NFFTdir='/home/math/imelzer/software/nfft-3.3_Phi/'; 

%add utilities
addpath('../utilities');



M2=N;
%MOmega=(1:N)'; %equispaced frequencies.
MOmega=N*sort(rand(M2,1));
M1=N;
ximax=N;
MX=N*rand(M1,1);

fhat=complex(rand(M2,1)-1/2,rand(M2,1)-1/2);
qstart=1;
qmax=20;


vecq=qstart:1:qmax;
err_nnfft=inf*ones(1,length(vecq));
err_bsfft=inf*ones(1,length(vecq));

savefile=sprintf('data/Phi_error1D_N%d.mat',N);
savefile=sprintf('data/test');  

for tmpq=1:length(vecq)
    q=vecq(tmpq);
    display(q)
    ymax=(2*q-1)*log(2);
    MY=ymax*sort(rand(M1,1));
    u_ex=u_exactall(MY,MX,MOmega,N,fhat);
    
    display('NNFFLT')
    plan1=XFLT('NNFFLT',MY,'rank',q,'libdir',NFFTdir,'MX',MX,'MOmega',MOmega,'N',N);
    f1=mtimes(plan1,fhat);
    clear plan1;
    
        
    display('BSFFLT')
    p=ceil(q/2)+3;
    plan2=XFLT('BSFFLT',MY,'rank',q,'MX',MX,'MOmega',MOmega,'N',N,'BSFFTrank',p);
    f2=mtimes(plan2,fhat);
    
    
    
    
    max(abs(u_ex-f1))
    max(abs(u_ex-f2))
    
    
    
    err_nnfft(tmpq)=norm(f1-u_ex,Inf)/(norm(fhat,1));
    err_bsfft(tmpq)=norm(f2-u_ex,Inf)/(norm(fhat,1));
    
    
    
    save(savefile,'qstart','q','N','MX','MY','MOmega','fhat','err_nnfft','err_bsfft')
end




