% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%
y1=10;
%y1=7;
xi1=5;
ep=3*10^-1;
M=ceil(log2(y1*xi1/ep))+1

YM=y1/2^(M-1);

y=0:0.01:y1;
xi=0:0.01:xi1;
[Y,Xi]=meshgrid(y,xi);

kappa=exp(-Y.*Xi);

kappa(Y<y1/2^(M-1))=0;
kappa(Xi<xi1/2^(M-1))=0;
M
for m=1:M-1
  %xi2=xi(xi<xi1/2^M+1-m);
  kappa(y1/2^m<Y & Y<=y1/2^(m-1) & Xi > xi1/2^floor(log2(y1*xi1)-m-log2(log(1/ep))))=1;
  kappa(y1/2^m<Y & Y<=y1/2^(m-1) & Xi < xi1/2^(M+2-m))=0;
end;
  
imagesc(y,xi,kappa)
colormap(gray(256));
set(gca,'YDir','normal');
axis equal
axis tight
%colorbar

ym=y1./2.^(1:M);
xim=xi1./2.^(1:M);
hold on
for m=1:M
  h=plot(ym(m)*ones(size(xi)),xi,'k-',y,xim(m)*ones(size(y)),'k-');
  %set(h,'Linewidth',1);
end
hold off

%set(gca,'LooseInset',get(gca,'TightInset'))
%print showKappa.pdf -dpdf
%pdfcrop showKappa.pdf
export_fig -transparent ../../showKappa.pdf


