% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%
addpath('/home/math/imelzer/software/export_fig')
addpath('../utilities');
addpath('data');

%%
h = figure(1);
clf(h);
s = get(h,'Position');
set(h,'Position',[s(1:2),s(3)+200,s(4)+200]);
    file1='Phi_error1D_LT_N1024';
    load(file1)
    vecq=qstart:q;
    h(1)=semilogy(vecq,err,'k+');
    hold on
    h(2)=semilogy(vecq,err_theor,'k-');
    %least square fit
    tmpvec=1:19;
    [k_LT,C_LT]=least_squares(2*vecq(tmpvec)',err(tmpvec)');

    h(3)=semilogy(vecq(tmpvec),C_LT*k_LT.^(-2*vecq(tmpvec)),'k-.');    
    %xlabel('q')
    %ylabel('\epsilon')
    fs=14;
    set(gca,'Fontsize',fs);
     set(get(gca,'title'),'Fontsize',fs);
     set(get(gca,'XLabel'),'Fontsize',fs);
     set(get(gca,'YLabel'),'Fontsize',fs);
     for j=1:length(h)
        set(h(j),'linewidth',2,'MarkerSize',8)
     end

    axis([1,20,10^(-18),10^0])
    set(gca,'XTick',1:2:20)
    vec_y=fliplr(0:2:18);
    set(gca,'YTick',10.^(-vec_y))
    hold off;
    export_fig(gcf,strcat('../../',file1),'-pdf','-transparent')

     
 
 close all;
 clear all;
 
% %%
g = figure(2);
clf(g);
s = get(g,'Position');
set(g,'Position',[s(1:2),s(3)+200,s(4)+200]);
file2='Phi_error1D_LT_N16384';
    load(file2)
    vecq=qstart:q;
    g(1)=semilogy(vecq,err,'k+');
    hold on
    g(2)=semilogy(vecq,err_theor,'k-');
    %least square fit
    tmpvec=1:18;
    [k_LT,C_LT]=least_squares(2*vecq(tmpvec)',err(tmpvec)');

    g(3)=semilogy(vecq(tmpvec),C_LT*k_LT.^(-2*vecq(tmpvec)),'k-.');    
    %xlabel('q')
    %ylabel('\epsilon')
    fs=14;
    set(gca,'Fontsize',fs);
     set(get(gca,'title'),'Fontsize',fs);
     set(get(gca,'XLabel'),'Fontsize',fs);
     set(get(gca,'YLabel'),'Fontsize',fs);
     for j=1:length(g)
        set(g(j),'linewidth',2,'MarkerSize',8)
     end

    axis([1,20,10^(-18),10^0])
    set(gca,'XTick',1:2:20)
    vec_y=fliplr(0:2:18);
    set(gca,'YTick',10.^(-vec_y))
    hold off;
    export_fig(gcf,strcat('../../',file2),'-pdf','-transparent')
