% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%
addpath('/home/math/imelzer/software/export_fig')
addpath('../utilities');
addpath('data');

% %%
h=figure(1);
%BSFFLT
load('Phi_error1D_poly_disc_N16384')



    vecq=qstart:q;
    vecp=ceil(vecq/2)+3;
    L=log2(N);
    kp=(2*pi^2./((1-cos(2*pi./(vecp-1))).*(vecp-1).^2)).^((vecp-1)/2);
    Cp=kp.*(1+2/pi*log(vecp));
    err_theor=10^(-6)*((2.^(1-2*vecq) + (Cp+1).*(Cp.^(L+1)-1)./(pi*vecp.*(Cp-1)).*(pi./(vecp-1)).^vecp.*(1+2.^(1-2*vecq))));
    
    h(1)=semilogy(vecq,err_bsfft,'k+');
    hold on
    %h(2)=semilogy(vecq,err_theor,'k-');
    %least square fit
    tmpvec=1:15;
    [k_LT,C_LT]=least_squares(2*vecq(tmpvec)',err_bsfft(tmpvec)');

    h(2)=semilogy(vecq(tmpvec),C_LT*k_LT.^(-2*vecq(tmpvec)),'k-.');    
    %xlabel('q')
    %ylabel('\epsilon')
    fs=14;
    set(gca,'Fontsize',fs);
     set(get(gca,'title'),'Fontsize',fs);
     set(get(gca,'XLabel'),'Fontsize',fs);
     set(get(gca,'YLabel'),'Fontsize',fs);
     for j=1:length(h)
        set(h(j),'linewidth',2,'MarkerSize',8)
     end
    axis([1,20,10^(-16),10^0])
    set(gca,'XTick',1:2:20)
    vec_y=fliplr(0:2:18);
    set(gca,'YTick',10.^(-vec_y))
    hold off
    savepic='../../Phi_error1D_BSFFLT_poly_disc_N16384';
    export_fig(gcf,savepic,'-pdf','-transparent')
    
% 
% %%
h=figure(2);
 %load('Phi_error1D_NFFLT_N16384')
 %vecq=qstart:q;
 vecm=vecq;
 err_theor=(2.^(1-2*vecq)+4*pi/2^(1/4)*exp(-sqrt(2)*pi*vecm).*(sqrt(vecm)+vecm).*(1+2.^(1-2*vecq)));
 
    h(1)=semilogy(vecq,err_nfft,'k+');
    hold on
    h(2)=semilogy(vecq,err_theor,'k-');
    %least square fit
    tmpvec=1:15;
    [k_LT,C_LT]=least_squares(2*vecq(tmpvec)',err_nfft(tmpvec)');

    h(3)=semilogy(vecq(tmpvec),C_LT*k_LT.^(-2*vecq(tmpvec)),'k-.');    
    %xlabel('q')
    %ylabel('\epsilon')
    fs=14;
    set(gca,'Fontsize',fs);
     set(get(gca,'title'),'Fontsize',fs);
     set(get(gca,'XLabel'),'Fontsize',fs);
     set(get(gca,'YLabel'),'Fontsize',fs);
     for j=1:length(h)
        set(h(j),'linewidth',2,'MarkerSize',8)
     end
    axis([1,20,10^(-16),10^0])
    set(gca,'XTick',1:2:20)
    vec_y=fliplr(0:2:18);
    set(gca,'YTick',10.^(-vec_y))
    hold off;
    savepic='../../Phi_error1D_NFFLT_poly_disc_N16384';
    export_fig(gcf,savepic,'-pdf','-transparent')