% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%
clear all;
close all;


addpath('/home/math/imelzer/software/export_fig')
addpath('../utilities');
addpath('data');
%figure 2

q=4;
%q=8;

%Laplace
    file=sprintf('Phi_times1D_LT_q%d',q);
    load(file)
    L_begin=vec_s(1);
    L_end=vec_s(end);
    vec_N=2.^(vec_s).';
    %maxLex=L_end+1;
    if L_end>maxLex
        vec_s2=(L_begin:1:maxLex).';
    else vec_s2=vec_s.';
    end
    %vec_s2=vec_s.';

    vec_N2=2.^(vec_s2);
    %larger figur
    h = figure(1);
    clf(h);
    s = get(h,'Position');
    set(h,'Position',[s(1:2),s(3)+200,s(4)+200]);

    lex=size(t_ex1,1);
    C_ex1=least_squares_2(vec_N(7:lex),t_ex1(7:lex)); %C*N^2
    C_ex2=least_squares_2(vec_N(8:lex),t_ex2(8:lex)); %C*N^2
    C=least_squares_7(vec_N(12:end),t(12:end));%Laplace C*N
    h(1)=loglog(vec_N2,t_ex1,'kd');
    hold on
    h(2)=loglog(vec_N2,t_ex2,'kd');
    h(3)=loglog(vec_N,t,'k+');
    h(4)=loglog(vec_N(7:lex),C_ex1*(vec_N(7:lex)).^2,'k-');
    h(5)=loglog(vec_N(8:lex),C_ex2*(vec_N(8:lex)).^2,'k-');
    h(6)=loglog(vec_N(12:end),C*vec_N(12:end),'k-.');
    gerade3=sprintf('naive, %.2e N^2',C_ex1);
    gerade4=sprintf('%.2e N',C);
    %legend('naive 1','naive 2','LT',gerade3,gerade4,'Location','NorthWest')
    %axis([2,vec_s(end),10^(-4),max([t_ex;t])+1])
   % hold off;
    %str=sprintf('Laufzeittest fuer p=%d',p);
    %title(str)
%     ylabel('time in s')
%     xlabel('N')
    axis([1,2^(24),10^(-3),10^(2.5)])
    set(gca,'YTick',10.^(-3:1:3))
    fs=14;
    set(gca,'XTick',2.^(vec_s(1:3:end))+1)
    set(gca, 'XTickLabel',[])                      %# suppress current x-labels
    xt = vec_s(1:3:end);
    yl = get(gca, 'YLim');
    str = cellstr( num2str(xt(:),'2^{%d}') );      %# format x-ticks as 2^{xx}
    text(vec_N(1:3:end), yl(ones(size(xt))), str, ...   %# create text at same locations
    'Interpreter','tex', ...                   %# specify tex interpreter
    'VerticalAlignment','top', ...             %# v-align to be underneath
    'HorizontalAlignment','center', ...
    'Fontsize',fs);   
   
    set(gca,'Fontsize',fs);
     set(get(gca,'title'),'Fontsize',fs);
     set(get(gca,'XLabel'),'Fontsize',fs);
     set(get(gca,'YLabel'),'Fontsize',fs);
     for j=1:length(h)
        set(h(j),'linewidth',2,'MarkerSize',8)
     end
     
    hold off
    savepic=strcat('../../',file);
    export_fig(gcf,savepic,'-pdf','-transparent')
