% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate$
% $Author$
% $Revision$
%
addpath('/home/math/imelzer/software/export_fig')
addpath('../utilities');
addpath('data')

set(0,'defaulttextinterpreter','latex')
q=4;

%Butterfly-LT
    
    file=sprintf('Phi_times1D_poly_disc_q%d',q);
    %file=sprintf('Phi_times1D_q%d',q);
       
    load(file)
    L_begin=vec_s(1);
    L_end=vec_s(end);
    vec_N=2.^(vec_s).';
    if L_end>maxLex
        vec_s2=(L_begin:1:maxLex).';
    else vec_s2=vec_s.';
    end

    vec_N2=2.^(vec_s2);
    %larger figur
    h = figure(1);
    clf(h);
    s = get(h,'Position');
    set(h,'Position',[s(1:2),s(3)+200,s(4)+200]);
    
    
    lex=size(t_ex1,1);
    C_ex1=least_squares_2(vec_N2(7:end),t_ex1(7:lex)); %C*N^2
    C_ex2=least_squares_2(vec_N2(8:end),t_ex2(8:lex)); %C*N^2
    %size(vec_N)
    %size(t_bsfft)
   
    C_bsfft=least_squares_3(vec_N(3:end),t_bsfft(3:end)); %C*NlogN %BSFFLT
    C_nfft=least_squares_3(vec_N(3:end),t_nfft(3:end)); %C*NlogN %BSFFLT
    
    h(1)=loglog(vec_N2,t_ex1,'kd');
    hold on
    h(2)=loglog(vec_N2,t_ex2,'kd');
    h(3)=loglog(vec_N,t_bsfft,'k+');
    h(4)=loglog(vec_N(7:lex),C_ex1*(vec_N(7:lex)).^2,'k-');
    h(5)=loglog(vec_N(8:lex),C_ex2*(vec_N(8:lex)).^2,'k-');
    h(6)=loglog(vec_N(3:end),C_bsfft*(vec_s(3:end).').*vec_N(3:end),'k-.');
    gerade3=sprintf('naive, %.2e N^2',C_ex1);
    gerade4=sprintf('%.2e N log_2 N',C_bsfft);
    
    h(7)=loglog(vec_N,t_nfft,'k*');
    h(8)=loglog(vec_N(3:lex),C_ex1*(vec_N(3:lex)).^2,'k--');
    h(9)=loglog(vec_N(3:end),C_nfft*(vec_s(3:end).').*vec_N(3:end),'k:');

    %legend('naive 1','naive 2','BSFFLT',gerade3,gerade4,'NFFLT naive 1','NFFLT naive 2','NFFLT','NFFLT naive fit','N log N fit NFFLT','Location','NorthWest')
    axis([1,2^(16),10^(-3),10^(4.5)])
    fs=14;
    set(gca,'XTick',2.^(vec_s(1:3:end))+1)
   
    set(gca, 'XTickLabel',[])                      %# suppress current x-labels
    xt = vec_s(1:3:end);
    %yl = get(gca, 'YLim');
    yl=10^-3;
    str = cellstr( num2str(xt(:),'2^{%d}') );      %# format x-ticks as 2^{xx}
    text(vec_N(1:3:end), yl(ones(size(xt))), str, ...   %# create text at same locations
    'Interpreter','tex', ...                   %# specify tex interpreter
    'VerticalAlignment','top', ...             %# v-align to be underneath
    'HorizontalAlignment','center', ...
    'Fontsize',fs);   

   
    %set(gca,'xticklabel',{'2^1','2^4','2^6','2^8','2^10','2^12'});
    set(gca,'Fontsize',fs);
     set(get(gca,'title'),'Fontsize',fs);
     set(get(gca,'XLabel'),'Fontsize',fs);
     set(get(gca,'YLabel'),'Fontsize',fs);
     for j=1:length(h)
        set(h(j),'linewidth',2,'MarkerSize',8)
     end
    hold off
    savepic=strcat('../../',file);
    export_fig(gcf,savepic,'-pdf','-transparent')

