% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $

%Before you call this script, you have to call the script compute1D_relative_error_box.
%Don't forget to set the file correct!


%file='relative_error1D_box_L10_r900';
%file='relative_error1D_box_L14_r900';

file='relative_error1D_box_L10';  %see figure 4.1. (a) in the paper
%file='relative_error1D_box_L14'; %see figure 4.1. (b) in the paper

loadfile=strcat('../data/',file);
load (loadfile)

	
n=length(err_hh);
p=(pmin:1:pmin+n-1)';

C_p=(2*pi.^p)./(4.^(p-1).*factorial(p)-pi.^p);

%larger figur
h = figure(1);
clf(h);
s = get(h,'Position');
set(h,'Position',[s(1:2),s(3)+200,s(4)+200]);

h(1)=semilogy(p,err_th,'bd-');
hold on
h(2)=semilogy(p,err_tt,'rs-');
h(3)=semilogy(p,err_tmaxh,'mo-');
h(4)=semilogy(p,err_tmaxtmax,'gx-');
h(5)=semilogy(p,err_hh,'k>-');
h(6)=semilogy(p,err_lag,'c+-');
h(7)=semilogy(p,C_p,'--');
h(8)=semilogy(p,eps*k,'r-.');
set(h(7),'Color',[1/2,1/2,0]);
str='\kappa(G) eps';

fs=14;
set(gca,'Fontsize',fs);
set(get(gca,'XLabel'),'Fontsize',fs);
set(get(gca,'YLabel'),'Fontsize',fs);

xlabel('p');
ylabel('r_{1,\infty}(\alpha,\beta)');
legend('r_{1,\infty}(t,h)','r_{1,\infty}(t,t)','r_{1,\infty}(t^{max},h)','r_{1,\infty}(t^{max},t^{max})','r_{1,\infty}(h,h)','Lagr.-Meth.','C_p',str,'Location','SouthWest')
axis([pmin-0.05,pmax,min([err_th;err_tt;err_tmaxh;err_tmaxtmax;err_hh;err_lag]),10^0])
set(gca,'XTick',pmin:1:pmax)
vec_y=fliplr(0:2:14);
set(gca,'YTick',10.^(-vec_y))
set(gca,'Fontsize',14);

for j=1:length(h)
	set(h(j),'linewidth',2,'MarkerSize',8);
end

savepic=strcat('../pics/',file);
saveas(gcf,savepic,'png')

