% XFFT - a Matlab toolbox to compute eXtended Fast Fourier transforms
% 
% Copyright (C) 2015 Ines Melzer
% 
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
% 
% $LastChangedDate: 2015-10-21 13:41:37 +0200 (Mi, 21. Okt 2015) $
% $Author: melzer $
% $Revision: 6165 $

function err=error_estimate(d,N,vec_p)
%Input: d -  dimension
%       N -  domain parameter
%       vec_p - index vector p
%Output: err - vector of theoretical error estimates  

%err:theoretical error estimate, see theorem 
L=log2(N);
K_p=(2*pi^2./((1-cos(2*pi./(vec_p-1))).*(vec_p-1).^2)).^(vec_p-1);
O_p=sqrt(K_p).*(2/pi*log(vec_p)+1); %operator norm
c_p=1./(pi*vec_p).*(pi./(vec_p-1)).^vec_p;
err=(O_p+1).*(O_p.^(d*(L+1))-1)./(O_p-1).*c_p;




end