function u=u_exactFFT(MY,fhat,varargin)
% computes the exact sums for each dimension d, just for comparison with the approximative sparse FFT
%
% u=u_exact(MX,MOmega,f,N)
%
% INPUT
%    MY      - sampling nodes in Y=[0,N] as row vector
%
% OUTPUT
%   u  complex column vector of length size(MX,1)

N=size(MY,1);
u=zeros(N,1);

MOmega=(0:1:N-1).';
MZ=MOmega./N+1i*MY./(2*pi);


if (~isempty(varargin))
   option=varargin;
else
    option=1;
end

switch(option)
    case 1
         for k=1:N
             u=u+(exp(2*pi*1i*MZ*MOmega(k))*fhat(k));
         end
    case 2
        for j=1:N
            for k=1:N

                u=u+(exp(2*pi*1i*MZ(j)*MOmega(k))*fhat(k));
            end
        end
    otherwise 
           display('unknown option for exact computation');
end


end